com.fasterxml.jackson.databind.jsontype.impl

## Class AsPropertyTypeSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.jsontype.TypeSerializer
  - - com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase
    - - com.fasterxml.jackson.databind.jsontype.impl.AsArrayTypeSerializer
      - - com.fasterxml.jackson.databind.jsontype.impl.AsPropertyTypeSerializer

Direct Known Subclasses:
  AsExistingPropertyTypeSerializer

    public class AsPropertyTypeSerializer
    extends AsArrayTypeSerializer

Type serializer that preferably embeds type information as an additional JSON Object property, if possible (when resulting serialization would use JSON Object). If this is not possible (for JSON Arrays, scalars), uses a JSON Array wrapper (similar to how `JsonTypeInfo.As.WRAPPER_ARRAY` always works) as a fallback.

### Field Summary

Fields
`protected String` `_typePropertyName`

### Fields inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

`_idResolver, _property`

### Constructor Summary

Constructors
Constructor and Description
`AsPropertyTypeSerializer(TypeIdResolver idRes, BeanProperty property, String propName)`

### Method Summary

All Methods Instance Methods Concrete Methods
`AsPropertyTypeSerializer` `forProperty(BeanProperty prop)` Method called to create contextual version, to be used for values of given property.
`String` `getPropertyName()` Name of property that contains type information, if property-based inclusion is used.
`com.fasterxml.jackson.annotation.JsonTypeInfo.As` `getTypeInclusion()` Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.

### Methods inherited from class com.fasterxml.jackson.databind.jsontype.impl.TypeSerializerBase

`_generateTypeId, getTypeIdResolver, handleMissingId, idFromValue, idFromValueAndType, writeTypePrefix, writeTypeSuffix`

### Methods inherited from class com.fasterxml.jackson.databind.jsontype.TypeSerializer

`_writeLegacySuffix, typeId, typeId, typeId, writeCustomTypePrefixForArray, writeCustomTypePrefixForObject, writeCustomTypePrefixForScalar, writeCustomTypeSuffixForArray, writeCustomTypeSuffixForObject, writeCustomTypeSuffixForScalar, writeTypePrefixForArray, writeTypePrefixForArray, writeTypePrefixForObject, writeTypePrefixForObject, writeTypePrefixForScalar, writeTypePrefixForScalar, writeTypeSuffixForArray, writeTypeSuffixForObject, writeTypeSuffixForScalar`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _typePropertyName

    protected final String _typePropertyName

### Constructor Detail

#### AsPropertyTypeSerializer

    public AsPropertyTypeSerializer(TypeIdResolver idRes,
                                    BeanProperty property,
                                    String propName)

### Method Detail

#### forProperty

    public AsPropertyTypeSerializer forProperty(BeanProperty prop)

Description copied from class: `TypeSerializer`
Method called to create contextual version, to be used for values of given property. This may be the type itself (as is the case for bean properties), or values contained (for `Collection` or `Map` valued properties).

Overrides:
  `forProperty` in class `AsArrayTypeSerializer`

#### getPropertyName

    public String getPropertyName()

Description copied from class: `TypeSerializer`
Name of property that contains type information, if property-based inclusion is used.

Overrides:
  `getPropertyName` in class `TypeSerializerBase`

#### getTypeInclusion

    public com.fasterxml.jackson.annotation.JsonTypeInfo.As getTypeInclusion()

Description copied from class: `TypeSerializer`
Accessor for type information inclusion method that serializer uses; indicates how type information is embedded in resulting JSON.

Overrides:
  `getTypeInclusion` in class `AsArrayTypeSerializer`